#pragma once


#include <J3ML/Geometry/Shape.hpp>
#include <J3ML/Geometry/LineSegment.hpp>

namespace J3ML::Geometry
{
    class Line : public Shape
    {
    public:
        Vector3 Position;  /// Specifies the origin of this line.
        Vector3 Direction; /// The normalized direction vector of this ray.

        Line(const Vector3& position, const Vector3& direction) : Position(position), Direction(direction) {}

        static void ClosestPointLineLine(const Vector3 &v0, const Vector3 &v10, const Vector3 &v2, const Vector3 &v32, float &d, float &d2);

        Vector3 ClosestPoint(const J3ML::Geometry::LineSegment &other, float &d, float &d2) const;

        Vector3 GetPoint(float d) const;

        Vector3 ClosestPoint(const Vector3 &targetPoint, float &d) const;
    };
}